> For the complete documentation index, see [llms.txt](https://docs.nuvolos.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nuvolos.com/reference/applications/sessions.md).

# Sessions

A Nuvolos application is a set of resources and associated configurations. When you start the application, an **application session** is created. Every session is a single continuous run of the application, identified by a unique session identifier - `session_id`.

## View an Application's session history

An application's current and previous session information is available in Nuvolos. To access the session history of an application, open the Sessions page under the Actions button in the Applications list:

1. Navigate to the Space and Instance containing the Application.
2. Make sure you are in the **Current state**.
3. On the sidebar click the Screen button (**Applications**), which shows you the Application list.
4. On the row of the application of interest, click **...** under **Actions**.
5. Select **SESSIONS**.
6. The screen shows the sessions now for the given application.

### Session view columns

By default the session view shows:

* **Start / Stop Time -** when the session started and ended. An "active" indicator means the session is still running. The Start time column is searchable and date-filterable.
* **Runtime -** Actual running time (HH:MM:SS) of the application's session.
* [**Size**](/reference/applications/application-resources.md#size-and-price-of-an-application) **-** Resource configuration (CU / Node pool) used for the application at the time the session was started.
* **Credits Spent - T**otal Credits consumed by the session. Only applicable to [credit-based sizes](/reference/applications/application-resources.md#size-and-price-of-an-application); not shown for NCU configurations.
* **Actions menu (...) -** View the saved logs of the session via **SEE LOGS**.

Additional columns can be added via the COLUMNS button:

* **Session ID -** Unique session identifier. Use this in support requests to specify the run in question.
* **Start / Stop user -** display name of the user who started or stopped the session. Stop and start users may differ for shared Applications, or when the system scheduler terminated the Application due to [inactivity](/reference/applications/long-running-applications.md#automatic-stopping-due-to-inactivity).
* **Sidecar size -** Total CU size of **all the sidecars** (a.k.a. [Add-ons](/reference/applications/add-ons.md)) configured to run alongside the application for that session.
* [**CU hour**](/getting-started/glossary.md#cus) **-** total NCU hours consumed for the session, including the main Application usage and all sidecar usage.

## Session Logs

Being able to monitor the application's log outputs is crucial for efficient troubleshooting of your applications. The Session Logs function lets you do just that.

1. Navigate to the Space and Instance containing the Application.
2. Make sure you are in the **Current state**.
3. On the sidebar click the Screen button (**Applications**), which shows you the Application list.
4. On the row of the application of interest, click **...** under **Actions**.
5. Select **SESSIONS**.
6. The screen shows the sessions now for the given application.
7. To review the logs of a specific session, click the **...** menu under **Actions** and click **SEE LOGS**.

This will take you to the Session logs screen. The Application's name and the specific session's ID you are viewing are shown. The log output is shown in a descending order, i.e., the latest logs are shown at the bottom of the output window.

#### Log access rules

As a security measure, you can only see the logs for a specific session if:

* You started the session, or
* The Application was run in SHARED MODE for that specific session

#### Log retention and availability

* Logs are collected in real time but may be delayed up to a few minutes before they appear in the interface due to processing.
* Logs can be retrieved only for the last 7 days.
* The output is shown in descending order — the latest logs at the bottom.

### Log Interface Controls

1. Containers
   * Allows you to select which application or sidecar (a.k.a. [Add-on](/reference/applications/add-ons.md)) you wish to see the logs for
   * [**Main-App**](/reference/applications.md) is the application you have configured (e.g. Visual Studio Code, Jupyter Lab etc.)
   * Any **sidecar** configured to run alongside the application for this session (e.g. Redis, MongoDB etc.)
2. Show Timestamp
   * Toggle timestamp visibility in the output
   * Log messages may or may not have a timestamp in the message itself
3. Number of lines
   * Sets the maximum number of lines of logs that is displayed (default = 100 lines of log output)
4. Filter(s)
   * After Timestamp - Set a **timestamp only on or after** which such logs will be shown (default = no timestamp, so show the latest log messages)
   * Log text - Show logs to only those **containing the text specified.** Note that:

     * The filters are applied at different stages:
       * The timestamp and number of lines filters are applied first (i.e. at the time of query) then,
       * The text filters are applied in Nuvolos after the logs are retrieved.

     For example: there are 150 lines of log output for a given application, the last 100 of which are comprised of:

     * 50 lines with the text `warning`
     * 30 lines with empty log messages
     * 20 lines that do not contain the relevant text ("warning")

     With the default filters, before the `warning` text filter is applied, **the last 100 lines** of log output will be shown. When `warning` is typed in the text filter, the text filter is then applied, so the log output displays 50 lines with the relevant text.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.nuvolos.com/reference/applications/sessions.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
